<template>
	<div id="contact">
		<div id="body">
			<div class="container bg-light">
				<div class="row">
					<div class="col-md-12">
						<h3>Contact us</h3>
					</div>
					<div class="col-md-12" id="toptext">
						<h4 class="text-danger">Feel free to send us a message</h4>
					</div>	
					<div class="col-md-12">
						<AlertMsg v-if="message !== ''" :message="message"></AlertMsg>
					</div>
					<div class="col-md-1">
						<br>
						<input type="radio" name="gender" value="Mr." v-model="formdata.gender.value">Mr.
					</div>
					<div class="col-md-1">
						<br>
						<input type="radio" name="gender" value="Ms." v-model="formdata.gender.value">Ms.
					</div>			
					<div class="col-md-5">
						First name
						<input type="text" v:class="{'is-invalid' : isInvalid('firstname')}" class="form-control" :placeholder="mrMs" v-model="formdata.firstname.value">
					</div>
					<div class="col-md-5">
						Last name
						<input type="text" :class="{'is-invalid' : isInvalid('lastname')}" class="form-control" :placeholder="'doe'" v-model="formdata.lastname.value">
					</div>
					<div class="col-md-12">
						Subject
					</div>
					<div class="col-md-12">
						<input type="text" :class="{'is-invalid' : isInvalid('subject')}" class="form-control" v-model="formdata.subject.value">
					</div>
					<div class="col-md-12">
						Message
					</div>
					<div class="col-md-12">
						<input type="text" :class="{'is-invalid' : isInvalid('message')}" class="form-control" v-model="formdata.message.value">
					</div>				
				</div>
				<br>
				<hr>			
	        		<button @click="send()" class="btn btn-danger pull-right">
	          		Send <span class="glyphicon glyphicon-send"></span>
	        		</button>      
			</div>
		</div>		
	</div>
</template>

<script >
	
	import LocalPotato from '@/components/LocalPotato.vue'
	import AlertMsg from '@/components/AlertMsg.vue'

	export default{
		name: 'contact',
		components: {
			AlertMsg, 
		},
		data() {
				return{
					formdata: {
						gender: {
							value: 'Mr.',
							error: '',
						},
						firstname: {
							value: '',
							error: '',
						},
						lastname: {
							value: '',
							error: '',
						},
						subject: {
							value: '',
							error: '',
						},
						message: {
							value: '',
							error: '',
						},
					},
					errorFields: [],
					message: '',
				}
			},

			computed:{
				mrMs(){
					return this.formdata.gender.value === 'Mr.' ? 'john' : 'jane';
				}
			},

		methods:{
			send(){				
				const fields = Object.keys(this.formdata);
				this.errorFields = [];

				const ErrorLocation = fields.forEach((field)=>{
					this.validate(field);
					if(this.formdata[field].error !== ''){
						this.errorFields.push(field);
					}
				}
				)
				this.message = '';
				if(this.errorFields.length > 0){
					this.message = 'Please completely fill the form before sending.'
				}
			},

			validate(field){				
				this.formdata[field].error=''
				if(this.formdata[field].value===''){
					this.formdata[field].error='err'
				}
			},
			

			isInvalid(field){
				return this.errorFields.includes(field)
			},
		},				
	};
</script>